import pygame, os, sys
from pygame.locals import *
import gp2x

class JoyHandler:
	"""
	Handles joystick events.
	"""
	def __init__(self):
		num_joysticks = pygame.joystick.get_count()
		if num_joysticks > 0:
			stick = pygame.joystick.Joystick(0)
			stick.init()
		
		# list of buttons currently being held
		self.held = []
		for x in range(20): self.held.append(False)
		
		# list of buttons that just changed state
		self.changed = []
		for x in range(20): self.changed.append(False)
	
	def EventUpdate(self):
		doProcess = False
		# clear the changed array
		for x in range(20): self.changed[x] = False
		
		events = pygame.event.get()
		
		# look at each event
        	for e in events:
			# wtf does this do i don't even know
            		if e.type == QUIT:
				self.exit = True
			
			elif e.type == KEYDOWN:
				# catch the escape key
				if e.key == K_ESCAPE:
					sys.exit(0)
				else:
					doProcess = self.ButtonDown(gp2x.keySim(e.key))
			
			elif e.type == KEYUP:
				doProcess = self.ButtonUp(gp2x.keySim(e.key))
			
			# test for the joystick buttons
			# populate the held and changed arrays
			elif e.type == pygame.JOYBUTTONDOWN:
				doProcess = self.ButtonDown(e.button)

			elif e.type == pygame.JOYBUTTONUP:
				doProcess = self.ButtonUp(e.button)
		
		# if we've received joystick events then call the joystick
		self.Buttons()
	
	def ButtonDown(self, b):
		if self.held[b] == False:
			self.changed[b] = True
		self.held[b] = True
		return True
	
	def ButtonUp(self, b):
		if self.held[b] == True:
			self.changed[b] = True
		self.held[b] = False
		return True

