from gui.Label import Label
from gui.Numberbox import Numberbox
from gui.Toggle import Toggle
from gp2x.locals import *
import gp2x

class PdParser:
	"""
	PdParser is a very shit parser of Pd files to extract the gui elements out
	so we can replace them with fake ones.
	Should be expanded to support all the kinds of color variations etc. that Pd and IEMGUI elements support.
	"""
	def __init__(self, filename):
		pfile = file(filename)
		self.contents = pfile.read()
		pfile.close()
	
	def Parse(self):
		# get rid of carriage returns we don't care about
		contents = self.contents.replace(";\n", ";")
		contents = contents.replace("\n", " ")
		
		# look for the kinds of gui elements we know about
		for l in contents.split(";"):
			bits = l.split(" ")
			print bits
			if bits[0] == '#X':
				if bits[1] == "text":
					self.AddElement(Label(int(bits[2]), int(bits[3]), " ".join(bits[4:])))
				elif bits[4] == "nbx":
					print bits[21], int(bits[21])
					self.AddElement(Numberbox(int(bits[2]), int(bits[3]), bits[11], bits[12], int(bits[21]), float(bits[7]), float(bits[8])))
					self.AddElement(Label(int(bits[2]) + int(bits[14]), int(bits[3]) + int(bits[15]) - 10, bits[13]))
				elif bits[1] == "floatatom":
					self.AddElement(Numberbox(int(bits[2]), int(bits[3]), bits[10]))
				elif bits[4] == "tgl":
					self.AddElement(Toggle(int(bits[2]), int(bits[3]), bits[7]))
					self.AddElement(Label(int(bits[2]) + int(bits[10]), int(bits[3]) + int(bits[11]) - 10, bits[9]))

# test harness
if __name__ == '__main__':
	gp2x.init()
	def AddElement(e):
		print "adding", e
	parser = PdParser("all-guis.pd")
	parser.AddElement = AddElement
	parser.Parse()

