import pygame
from JoyHandler import JoyHandler
from instruments.FirstPage import FirstPage
import time
import gp2x
from gp2x.locals import *

class gp2xPd(JoyHandler):
	def __init__(self):
		# These are the objects we are going to use:
		# 	To send network messages to puredata
		#	To draw to the GP2X screen
		# 	To interperet joystick events
		pygame.init()
		gp2x.init()
		JoyHandler.__init__(self)
		
		# keep all our pages in an array
		self.first = FirstPage(self)
		self.currentPage = self.first
		self.pages = [self.first]
		
		# exit condition
		self.exit = False
	
	def Run(self):
		while not self.exit:
			self.EventUpdate()
			for p in self.pages:
				p.Update()
			gp2x.gfx.Update(self.currentPage)
			time.sleep(0.1)
	
	def Buttons(self):
		# check if any buttons we care about have been pressed, then call page's event function
		if self.changed[BUTTON_L] and self.held[BUTTON_L]:
			self.currentPage = self.pages[(self.pages.index(self.currentPage) - 1) % len(self.pages)]
		if self.changed[BUTTON_R] and self.held[BUTTON_R]:
			self.currentPage = self.pages[(self.pages.index(self.currentPage) - 1) % len(self.pages)]
		
		self.currentPage.Buttons()

# launch the main process
if __name__ == '__main__':
	#gp2x.init()
	#gp2x.net.Send("freq 60")
	app = gp2xPd()
	app.Run()

