from pygame import draw, Rect
from GuiElement import GuiElement
from gp2x.locals import *
import gp2x

class Numberbox(GuiElement):
	def __init__(self, x, y, send="", receive="", value=0, min=0, max=127, width=3, fontsize=10):
		self.wstr = "%%0%dd" % width
		self.width = gp2x.gfx.font.size(self.wstr % 0)[0]
		self.height = gp2x.gfx.font.get_linesize
		GuiElement.__init__(self, x, y)
		self.value = value 
		self.min = min
		self.max = max
		self.send = send
		self.receive = receive
	
	def DrawNormal(self):
		self.MakeText()
	
	def DrawSelected(self):
		self.MakeText([200, 0, 0])
	
	def MakeText(self, color=[0, 0, 0]):
		self.surf = gp2x.gfx.font.render(self.wstr % int(self.value), True, color)
		gp2x.gfx.screen.blit(self.surf, [self.x, self.y])
	
	def Buttons(self, changed, held):
		for (b, v) in [(BUTTON_LEFT, -1), (BUTTON_RIGHT, 1), (BUTTON_UP, 12), (BUTTON_DOWN, -12)]:
			if changed[b] and held[b]:
				self.Change(v)
	
	def Change(self, value):
		self.value += value
		if self.value < self.min:
			self.value = self.min
		elif self.value > self.max:
			self.value = self.max
		gp2x.net.Send(self.send + " " + str(self.value))
	
