from pygame import draw, Rect
from GuiElement import GuiElement
from gp2x.locals import *
import gp2x

class Toggle(GuiElement):
	def __init__(self, x, y, send="", receive="", value=1, size=15):
		self.size = size 
		self.width = size
		self.height = size
		GuiElement.__init__(self, x, y)
		self.value = value
		self.send = send
		self.receive = receive
		self.state = False
		
		self.rect = Rect([[x, y], [size, size]])
		self.lines = []
		self.lines.append([[x + 2, y + 2], [x + size - 3, y + size - 3]])
		self.lines.append([[x + size - 3, y + 2], [x + 2, y + size - 3]])
	
	def DrawNormal(self):
		self.DrawToggle()
	
	def DrawSelected(self):
		self.DrawToggle([200, 0, 0])
	
	def DrawToggle(self, color=[0, 0, 0]):
		draw.rect(gp2x.gfx.screen, color, self.rect, 1)
		if self.state:
			draw.lines(gp2x.gfx.screen, color, False, self.lines[0], 1)
			draw.lines(gp2x.gfx.screen, color, False, self.lines[1], 1)
	
	def Buttons(self, changed, held):
		if changed[BUTTON_B] and held[BUTTON_B]:
			self.state = not self.state
			gp2x.net.Send(self.send + " " + str((self.state and self.value) or 0))
	
